/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4                                               */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */



#include <stdio.h>
#include <stdlib.h>
#include "mydef.h"
#include "kernel.h"
#include "kernel_id.h"
#include "user_id.h"
#include "sh7045.h"
#include "sci.h"
#include "main.h"


#define SCIID			ID_SCI1




void SetDebugLed( void );		/* бLED */
void ResetDebugLed( void );		/* бLDEξ */



#ifdef GDBSTUB

void VECTOR_START( void );

/*
  ߥϥɥ

  GDB-STUBѥ롼Ǥ
  ٥ȥֹ inhno γߥϥɥεưϤ inthdr ꤹ롥
*/
inline void define_inh( INHNO inhno, FP inthdr )
{
    /*  ָƤӽФ  */
    __asm__ volatile("mov   #0x08,r0
                      mov   %0,r4
                      mov   %1,r5
                      trapa #0x21"
                     : /* no output */
                     : "r"(inhno),"r"(inthdr)
                     : "r0","r4","r5");
}
#endif


#ifndef GDBSTUB
/* Hardware(ɬפʽ) */
void hwinit( void )
{
#if 0
    *SH_WCR1 = 0x0002;
    *SH_WCR2 = 0x0000;
    *SH_BCR1 = 0x202f;
    *SH_BCR2 = 0x5500;
    
    /* WR, RD, CS, IRQ's, UART */
    *SH_PACRH = 0x5000;
    *SH_PACRL1 = 0x5550;
    *SH_PACRL2 = 0x0145;
    
    /* Add-BUS */
    *SH_PBCR1 = 0x000a;
    *SH_PBCR2 = 0xa005;
    
    /* DATA-BUS */
    *SH_PDCRH1 = 0x5555;
    *SH_PDCRH2 = 0x5555;
    *SH_PDCRL = 0xffff;
    
    /* Add-BUS */
    *SH_PCCR = 0xffff;
#endif

#if 1
    /* SH2 */
    *SH_WCR1 = 0x0000;
    *SH_BCR1 = 0x20af;
    *SH_BCR2 = 0x550f;
    *SH_PACRH = 0x5000;
    *SH_PACRL1 = 0x1540;
    *SH_PACRL2 = 0xad45;
    *SH_PBCR1 = 0x000a;
    *SH_PBCR2 = 0xa005;
    *SH_PCCR = 0xffff;
    *SH_PDCRH1 = 0x5555;
    *SH_PDCRH2 = 0x5555;
    *SH_PDCRL = 0xffff;
#endif
}
#endif


/* ᥤؿ */
int main( void )
{
    /* I/O ν */
    *SH_PEIOR = 0x0200;		/* 礨debug-LED */
    *SH_PEDR  = 0x0000;

#ifdef GDBSTUB
    /* gdb-stub˳ߥϥɥϿ */
    /* CMT0 */
    define_inh( SH_INTNUM_CMI0, (FP)*(DWORD *)(VECTOR_START+SH_INTNUM_CMI0*4) );
#endif
	
    /* HOS-V4 γ */
    sta_hos();
	
    return 0;
}


/* ATT_INI Ͽδؿ */
void MainInitialize(VP_INT exinf)
{
    /* ư */
    act_tsk(TSKID_SECJOB);
}


/* 1ư */
void SecTask(VP_INT exinf)
{
    BYTE byDebugLedFlag;


    byDebugLedFlag = 0;


    /* 1˵ưEVENT */
    for ( ; ; ) {
        /* debug-LED / */
        byDebugLedFlag ^= 0x01;
        if ( byDebugLedFlag ) {
            SetDebugLed();
        } else {
            ResetDebugLed();
        }

        /* Ԥ */
        dly_tsk( 1000 );
    }
}


/* бLED */
void SetDebugLed( void )
{
    wai_sem(SEMID_SYSCS);
    *SH_PEDR &= ~BIT( 9 );
    sig_sem(SEMID_SYSCS);
}


/* бLEDξ */
void ResetDebugLed( void )
{
    wai_sem(SEMID_SYSCS);
    *SH_PEDR |= BIT( 9 );
    sig_sem(SEMID_SYSCS);
}


/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
