OUTPUT_FORMAT("coff-sh")
OUTPUT_ARCH(sh)
MEMORY
{
  /* ¢ROM 0x000000000x0003ffff */
  /* RAM 0x004000000x004fffff */
  /* ¢I/O 0xffff80000xffff87ff */
  /* ¢RAM 0xfffff0000xffffffff */

  vector : o = 0x00000000, l = 0x00000400
  rom    : o = 0x00000400, l = 0x00040000 - 0x00000400
  ram    : o = 0x00400000, l = 0x00100000
  stack  : o = 0xfffffff0, l = 0x00000010
}
SECTIONS
{
  .vector :
  {
    _VECTOR_START = . ;
    *(.vector)
  } > vector
  
  .text :
  {
    _TEXT_START = . ;
    *(.vector)
    *(.text)
    *(.strings)
    *(.rodata)
    _TEXT_END = . ;
  } > rom
  .data : AT (ADDR(.text) + SIZEOF(.text))
  {
    _DATA_ROM = ADDR(.text) + SIZEOF(.text) ;
    _DATA_START = . ;
    *(.data)
    _DATA_END = . ;
  } > ram
  .bss :
  {
    _BSS_START = . ;
    *(.bss)
    *(COMMON)
    _BSS_END = . ;
    _end = . ;
  } > ram
  .stack :
  {
    _STACK_START = . ;
    *(.stack);
    _STACK_END = . ;
  } > stack
}
