/* Support for Serial I/O using on chip uart */

/* sh-stub.c -- debugging stub for the Hitachi-SH. 

 NOTE!! This code has to be compiled with optimization, otherwise the 
 function inlining which generates the exception handlers won't work.
 
*/

/*   This is originally based on an m68k software stub written by Glenn
     Engel at HP, but has changed quite a bit. 

     Modifications for the SH by Ben Lee and Steve Chamberlain

*/

/****************************************************************************

		THIS SOFTWARE IS NOT COPYRIGHTED

   HP offers the following for use in the public domain.  HP makes no
   warranty with regard to the software or it's performance and the
   user accepts the software "AS IS" with all faults.

   HP DISCLAIMS ANY WARRANTIES, EXPRESS OR IMPLIED, WITH REGARD
   TO THIS SOFTWARE INCLUDING BUT NOT LIMITED TO THE WARRANTIES
   OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

****************************************************************************/

/*
 *  @(#) $Id: sh-sci.7145.c,v 1.1.1.2 2004/10/07 08:37:33 hori Exp $
 */

/*
 *  쥸ѷ
 */
typedef unsigned char   byte;
typedef volatile byte   IOREG;
typedef unsigned short  word;
typedef volatile word   HIOREG;
typedef volatile int    LIOREG;

#define MSTCR1	((HIOREG *)0xffff861c)

#define SCR1	(IOREG *)0xffff81b2
#define SSR1	(IOREG *)0xffff81b4
#define BRR1	(IOREG *)0xffff81b1
#define SMR1	(IOREG *)0xffff81b0
#define TDR1	(IOREG *)0xffff81b3
#define RDR1	(IOREG *)0xffff81b5
#define SDCR1	(IOREG *)0xffff81b6

void handleError (char theSSR);

#define IPRF    ((HIOREG *)0xffff8352)
#define PACRL2	((HIOREG *)0xffff838e)

#define	__int32	int			/* 32ӥåȤ */
typedef	unsigned __int32	UW;	/* ̵32ӥå */
typedef unsigned int	UINT;		/* ʥ̵ */
/*  饤ؿ  */
#define Inline	static __inline__ 

#define SCI_SHIFT	0	/*  ߥ٥ϿΥӥåȥե  */
//#define SCI_BRR ((char)19)	/* 38400 */
#define SCI_BRR ((char)7)	/* 115200 */

#define SCI_TIE		0x80	/* ȥ󥹥ߥåȥ󥿥ץȥ֥͡ */
#define SCI_RIE		0x40	/* 쥷֥󥿥ץȥ֥͡ 	*/
#define SCI_TE		0x20	/* ȥ󥹥ߥåȥ֥͡ 		*/
#define SCI_RE		0x10	/* 쥷֥֥͡ 			*/

#define SCI_ORER	0x20	/* С󥨥顼 			*/
#define SCI_FER		0x10	/* ե졼ߥ󥰥顼 			*/
#define SCI_PER		0x08	/* ѥƥ顼 			*/
#define SCI_TDRE	0x80	/* ȥ󥹥ߥåȥǡ쥸ץƥ */
#define SCI_RDRF	0x40	/* 쥷֥ǡ쥸ե 		*/

#define PACRL2_TXD1	0x0100
#define PACRL2_RXD1	0x0040


Inline void
define_int_plevel(HIOREG *reg, UW level, UINT shift)
{
    *reg = (HIOREG)((*reg & ~(0xf << shift)) | (level << shift));
}

void
nop ()
{

}

void
init_serial()
{
    int i;

	*MSTCR1 &= ~0x0002;
	/* ߥ٥ */
	define_int_plevel(IPRF, 0xf, SCI_SHIFT);
	*SDCR1 = 0xf0;

	*SCR1 = 0x00;		/*    */
    *SMR1 = 0x00;		/*  ĴƱ  */
				/*  8ӥåȡѥƥʤ  */
				/*  ȥåץӥåȥ󥰥1 	*/
    *BRR1 = SCI_BRR;	/*  ܡ졼 */

  /* let the hardware settle */

	for (i = 0; i < 1000; i++)
		nop ();

	*PACRL2 |= (PACRL2_TXD1 | PACRL2_RXD1);	/*  SCI1ǡϥݡȤ  */
	*SSR1 &= ~(SCI_PER | SCI_FER | SCI_ORER);
	*SCR1 = (SCI_RIE | SCI_TE | SCI_RE);	/*  ġߵ  */
}

int
getDebugCharReady (void)
{
  unsigned short mySSR;
  mySSR = (*SSR1) & (SCI_PER | SCI_FER | SCI_ORER);
  if ( mySSR )
    handleError ( mySSR );
  return (*SSR1) & SCI_RDRF ;
}
char 
getDebugChar (void)
{
  char ch;
  unsigned short mySSR;

  while ( ! getDebugCharReady())
    ;

  ch = (*RDR1);
  (*SSR1) &= ~SCI_RDRF;

  mySSR = (*SSR1) & (SCI_PER | SCI_FER | SCI_ORER);

  if (mySSR)
    handleError (mySSR);

  return ch;
}

int 
putDebugCharReady()
{
  return ((*SSR1) & SCI_TDRE);
}

void
putDebugChar (char ch)
{
  while (!putDebugCharReady())
    ;

  /*
   * Write data into TDR and clear TDRE
   */
  *TDR1 = ch;
  *SSR1 &= ~SCI_TDRE;
  
}

void 
handleError (char theSSR)
{
  *SSR1 &= ~(SCI_PER | SCI_FER | SCI_ORER);
}


/*	^C(\003)ߤˤ⡼ȥ֥졼
 *	ƤФȤˤϳ߶ػߤˤʤäƤIPM=0xf
 *	Τᡢ2ʸܰʹߤϼߤˤʤʤ
 *	stub˼ߤϼդʤ
 *	ݡ󥰤ˤ
 */
void handle_remote_break(void)
{
  char ch;
  unsigned mySSR;
  
  if (getDebugCharReady) {	/*  ǡ  		*/
	ch = (*RDR1);		/*  ǡ(^C)ɤ߽Ф  	*/
	*SSR1 &= ~SCI_RDRF;	/*  ׵Υꥢ  	*/
  }

  mySSR = (*SSR1) & (SCI_PER | SCI_FER | SCI_ORER);

  if (mySSR)
    handleError (mySSR);
}
