/* Support for Serial I/O using on chip uart */

/* sh-stub.c -- debugging stub for the Hitachi-SH. 

 NOTE!! This code has to be compiled with optimization, otherwise the 
 function inlining which generates the exception handlers won't work.
 
*/

/*   This is originally based on an m68k software stub written by Glenn
     Engel at HP, but has changed quite a bit. 

     Modifications for the SH by Ben Lee and Steve Chamberlain

*/

/****************************************************************************

		THIS SOFTWARE IS NOT COPYRIGHTED

   HP offers the following for use in the public domain.  HP makes no
   warranty with regard to the software or it's performance and the
   user accepts the software "AS IS" with all faults.

   HP DISCLAIMS ANY WARRANTIES, EXPRESS OR IMPLIED, WITH REGARD
   TO THIS SOFTWARE INCLUDING BUT NOT LIMITED TO THE WARRANTIES
   OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

****************************************************************************/

/*
 *  @(#) $Id: sh-sci.c,v 1.1.1.3 2004/10/07 08:37:33 hori Exp $
 */


#include "sh-sci.h"
//#include "sh-stub.h"
//#include "mini_lib.h"

/*
 *  쥸ѷ
 */
typedef unsigned char   byte;
typedef volatile byte   IOREG;
typedef unsigned short  word;
typedef volatile word   HIOREG;
typedef volatile int    LIOREG;

#define SC1SSR1 ((volatile short *)(0xfffffcc8)) /* serial status register */
#define SCRDR1 ((volatile char *)(0xfffffccc)) /* receive data register 	*/
#define SCTDR1 ((volatile char *)(0xfffffcc6)) /* transmit data register */
#define SCSCR1 ((volatile char *)(0xfffffcc4)) /* serial control register */
#define SCFCR1 ((volatile char *)(0xfffffcce))
#define SCSMR1 ((volatile char *)(0xfffffcc0)) /* serial mode register 	*/
#define SCBRR1 ((volatile char *)(0xfffffcc2)) /* bit rate register 	*/


#define SCI_ER	0x0080		/* 쥷֥顼       */
#define SCI_RDRF		0x0002	/* Receive data register full */
#define SCI_TDRE		0x0020	/* Transmit data register empty */

#define IPRD    ((HIOREG *)0xfffffe40)

#define PBCR    ((HIOREG *)0xfffffc88)	/*  ݡB ȥ쥸  */

void handleError (char theSSR);

#define	__int32	int			/* 32ӥåȤ */
typedef	unsigned __int32	UW;	/* ̵32ӥå */
typedef unsigned int	UINT;		/* ʥ̵ */
/*  饤ؿ  */
#define Inline	static __inline__ 

#define SCI_SHIFT	0	/*  ߥ٥ϿΥӥåȥե  */
#define PBCR_TXD1 		 0x2000	/*  TXD1  	*/
#define PBCR_RXD1 		 0x0800	/*  RXD1  	*/
#define SCFCR_TFRST	0x04	/* ȥ󥹥ߥåFIFOǡ쥸ꥻå */
#define SCFCR_RFRST	0x02	/* 쥷FIFOǡ쥸ꥻå */
//#define SCI_BRR 	48/4-1	/*  ӥåȥ졼 38400 	*/
//#define SCI_BRR 	48/6-1	/*  ӥåȥ졼 57600 	*/
#define SCI_BRR 	48/12-1	/*  ӥåȥ졼 115200 	*/
/*  ꥢ륳ȥ쥸SCSCRΥӥå  */
#define SCSCR_TIE	0x80	/* ȥ󥹥ߥåȥ󥿥ץȥ֥͡ */
#define SCSCR_RIE	0x40	/* 쥷֥󥿥ץȥ֥͡ 	*/
#define SCSCR_TE	0x20	/* ȥ󥹥ߥåȥ֥͡ 		*/
#define SCSCR_RE	0x10	/* 쥷֥֥͡ 			*/

Inline void
define_int_plevel(HIOREG *reg, UW level, UINT shift)
{
    *reg = (HIOREG)((*reg & ~(0xf << shift)) | (level << shift));
}

void
nop ()
{

}

void
init_serial()
{
    int i;

	/* ߥ٥ */
	define_int_plevel(IPRD, 0xf, SCI_SHIFT);
	*SCSCR1 = 0x00;		/*    */
    *PBCR |= (PBCR_TXD1 | PBCR_RXD1);	/*  SCIF1ǡϥݡȤ  */
    *SCFCR1 = (SCFCR_TFRST | SCFCR_RFRST);	/*  FIFOν  */
    *SCSMR1 = 0x00;		/*  ĴƱ  */
				/*  8ӥåȡѥƥʤ  */
				/*  ȥåץӥåȥ󥰥1 	*/
    *SCBRR1 = SCI_BRR;	/*  ܡ졼 */

  /* let the hardware settle */

	for (i = 0; i < 1000; i++)
		nop ();

    *SCFCR1 = 0x00;		/*  FIFO  */
    *SCSCR1 = (SCSCR_RIE | SCSCR_TE | SCSCR_RE);	/*  ġߵ  */
}

int
getDebugCharReady (void)
{
  unsigned short mySSR;
  mySSR = (*SC1SSR1) & SCI_ER;
  if ( mySSR )
    handleError ( mySSR );
  return (*SC1SSR1) & SCI_RDRF ;
}
char 
getDebugChar (void)
{
  char ch;
  unsigned short mySSR;

  while ( ! getDebugCharReady())
    ;

  ch = (*SCRDR1);
  (*SC1SSR1) &= ~SCI_RDRF;

  mySSR = (*SC1SSR1) & SCI_ER;

  if (mySSR)
    handleError (mySSR);

  return ch;
}

int 
putDebugCharReady()
{
  return ((*SC1SSR1) & SCI_TDRE);
}

void
putDebugChar (char ch)
{
  while (!putDebugCharReady())
    ;

  /*
   * Write data into TDR and clear TDRE
   */
  *SCTDR1 = ch;
  *SC1SSR1 &= ~SCI_TDRE;
  
}

void 
handleError (char theSSR)
{
  *SC1SSR1 &= ~SCI_ER;
}


/*	^C(\003)ߤˤ⡼ȥ֥졼
 *	ƤФȤˤϳ߶ػߤˤʤäƤIPM=0xf
 *	Τᡢ2ʸܰʹߤϼߤˤʤʤ
 *	stub˼ߤϼդʤ
 *	ݡ󥰤ˤ
 */
void handle_remote_break(void)
{
  char ch;
  unsigned mySSR;
  
  if (getDebugCharReady) {	/*  ǡ  		*/
	ch = (*SCRDR1);		/*  ǡ(^C)ɤ߽Ф  	*/
	*SC1SSR1 &= ~SCI_RDRF;	/*  ׵Υꥢ  	*/
  }

  mySSR = (*SC1SSR1) & SCI_ER;

  if (mySSR)
    handleError (mySSR);
}
